/*********************************
 OneBitLoader for PIC24FJ64
  parameter definitions
  Ver 0.01 2015/05/31 by skyriver
  Ver 0.02 2015/09/21 change config2 OSCIOFNC_OFF to OSCIOFNC_ON to use RA3
 *********************************/

	.include "p24fj64ga002.inc"

	config __CONFIG1, FWDTEN_OFF & COE_OFF & BKBUG_OFF & GWRP_OFF & GCP_OFF & JTAGEN_OFF
	config __CONFIG2, POSCMOD_NONE & I2C1SEL_PRI & IOL1WAY_OFF & OSCIOFNC_ON & FCKSM_CSDCMD & FNOSC_FRCPLL & SOSCSEL_SOSC & WUTSEL_LEG & IESO_OFF


; internal closk 16MHz(4MHz x 4) (CLKDIV(reset:0x0100) RCDIV:001b)
.equ	F_CPU, 16000000			; CPU clock
.equ	StepRate, F_CPU / 2		; steps / sec
.equ	BaudRate, 38400			; bps
.equ	BitClk,(StepRate / BaudRate)
.equ	RcvTim,200				; recive timeover[ms]



; serial logic(if using level converter then set 1 else set 0)
.equ	SND_LOGIC,	1
.equ	RCV_LOGIC,	0


.macro	SETPORT,port,bit
 .macro	SETOUT
; 		bclr	TRIS\port,#\bit
 .endm

 .macro	SETIN
; 		bset	TRIS\port,#\bit
 .endm

 .macro	SERI_OUT_0
 	.IF (SND_LOGIC != 0)
 		bclr	TRIS\port,#\bit	; when reset PORT:0x0000, set out then 0 out
 	.ELSE
 		bset	TRIS\port,#\bit
 	.ENDIF
 .endm

 .macro	SERI_OUT_1
 	.IF (SND_LOGIC != 0)
 		bset	TRIS\port,#\bit
 	.ELSE
 		bclr	TRIS\port,#bit
 	.ENDIF
 .endm

 .macro	BTS_STARTBIT
 	.IF (RCV_LOGIC != 0)
 		btss	PORT\port,#\bit
 	.ELSE
 		btsc	PORT\port,#\bit
 	.ENDIF
 .endm

 .macro	BTS_BIT0
 	.IF (RCV_LOGIC != 0)
 		btsc	PORT\port,#\bit
 	.ELSE
 		btss	PORT\port,#\bit
 	.ENDIF
 .endm

 .macro	BTS_BIT1
 	.IF (RCV_LOGIC != 0)
 		btss	PORT\port,#\bit
 	.ELSE
 		btsc	PORT\port,#\bit
 	.ENDIF
 .endm

.endm


.equ	MAX_CMD,3		; now commands are 0,1,2
.equ	COMPACT_HEX,01	; if want to make compact hex_file then set 1 else set 0


; ++++++  chip depend definition ++++++

; <<< PIC24FJ64GA >>>

; define serial port and bit(except ANx)
		SETPORT	B 6
;		SETPORT	B 7

.equ	RcvBuf,		0x0881			; receive buffer(have to odd adress) 

.equ	PIC_ID,		'F'
.equ	ACK,		'o'
.equ	ROW_SIZE,	64				; word
.equ	PAGE_SIZE,	(ROW_SIZE * 8)	; word


.equ	ADRS_OFFSET, 0x0204			; cansel org offset(org 0 -> start 0x0204)
.equ	FLASH_END, 0x00ac00			; flash ROM end

.equ	DummyApAdrs,ADRS_OFFSET		; dummy ap start absolute address
.equ	BodyAdrs,(FLASH_END - ( 2 * PAGE_SIZE ) * 2)	; OneBitLoader body absolute address
.equ	IplAdrs,0xab5c				; IPL absolute address
